# -*- coding: utf-8 -*-

from PyQt5.QtCore import QCoreApplication

from Model.BoundaryCondition.BoundaryConditionTypes import (
    NotDefined, PonctualContribution,
    TimeOverZ, TimeOverDischarge, ZOverDischarge
)

_translate = QCoreApplication.translate

long_types = {
    "ND": _translate("BoundaryCondition", "Not defined"),
    "PC": _translate("BoundaryCondition", "Ponctual contribution"),
    "TZ": _translate("BoundaryCondition", "Time over Z"),
    "TD": _translate("BoundaryCondition", "Time over Discharge"),
    "ZD": _translate("BoundaryCondition", "Z over Discharge"),
}

table_headers = {
    "name": _translate("BoundaryCondition", "Name"),
    "type": _translate("BoundaryCondition", "Type"),
    "node": _translate("BoundaryCondition", "Node")
}

BC_types = {
    "ND": NotDefined,
    "PC": PonctualContribution,
    "TZ": TimeOverZ,
    "TD": TimeOverDischarge,
    "ZD": ZOverDischarge
}
